;------------   Exemple d'application avec un PIC : Un chennillard   ---------------

; Titre : Chennillard
; Date : 01 MARS 2010
; Auteur : P.M
; PIC utilis : PIC 16 F 88
; On ralise un chennillard sur les broches RB0  RB7  d' un PIC 16 F 88
; le quartz est de 4 Mhz , on effectue une tempo  environ gale  0.2 seconde 
; un bouton marche sur le port A permet de lancer l' application 

;------------   Directive d' assemblage pour PLAB   ---------------

	list	p=16f88
	#include p16f88.inc
    errorlevel -302
    __CONFIG  _CONFIG1, _CCP1_RB0&_LVP_OFF&_MCLR_ON&_PWRTE_ON&_WDT_OFF&_HS_OSC                      
    __CONFIG  _CONFIG2, _IESO_OFF & _FCMEN_OFF



;------------   Dfinition des constantes   ---------------


#define inter0 0	   ; bouton marche
					
;------------   Dfinition des registres    ---------------

retard1      EQU        0x20      ; le registre temporaire retard1 se trouve  l' adresse 20
retard2      EQU        0x21      ; le registre temporaire retard2 se trouve  l' adresse 21
memo	     EQU        0x22      ; le registre temporaire memo se trouve  l' adresse 22


;------------   Init des ports A et B   ---------------

	BANKSEL ANSEL 			; Selection Bank du registre ANSEL
	MOVLW 0x00 				; Configure toutes les broches
	MOVWF ANSEL 			; en mode digital

	MOVLW 0x00            	; on met 00 dans le registre W
	MOVWF TRISB           	; on met 00 dans le port B il est programm en sortie

	MOVLW 0x3f            	; on met 3F dans le registre W
	MOVWF TRISA           	; on met 3F dans le port A il est programm en entre
	

;------------   Init des leds  et registre ---------------

	banksel memo			;slection Bank 0
	clrf  PORTB            ; on met 0 sur le port B ( leds )
	MOVLW  01	      	    ; on met 01 dans le registre W 
	MOVWF  memo             ; on met W dans le registre memo

;--------------------   Programme principal   ----------------------

debut


	btfss PORTA,inter0	 ; interrupteur 0 ( marche ) appuy ? si oui on continu sinon va  debut
	goto debut

	movf memo,W		; on met memo dans W
	movwf PORTB		; on met W sur le port B ( leds )

	CALL  tempo             ; on appel la temporisation 
	RLF memo, F	        ; rotation  gauche du registre memo

	GOTO  debut             ; retour au dbut du programme

;------------   Programme de temporisation longue   ---------------

tempo
	MOVLW 0xff            ; on met ff dans le registre W
	MOVWF retard1         ; on met W dans le registre retard1 
	MOVWF retard2         ; on met W dans le registre retard2 

attente

	DECFSZ retard1,F       ; on dcrmente retard1 et on saute la prochaine instruction si 
	GOTO  attente            ; le registre retard1 = 0 sinon retour  tempo

	movlw 0xFF	     ; on recharge retard1
	movwf retard1

	DECFSZ retard2,F       ; on dcrmente retard2 et on saute la prochaine instruction si 
	GOTO  attente            ; le registre retard2 = 0 sinon retour  tempo

	  
	RETURN                   ; retour au programme principal aprs l 'instruction CALL

	END
 






